#ifndef LIBSARIA_LIBRARY_H
#define LIBSARIA_LIBRARY_H

#include <libsaria/track.h>
#include <libsaria/model.h>

#include <list>
#include <string>
using namespace std;

namespace libsaria
{
	namespace library
	{

		namespace iter
		{
			void reset();
			libsaria::Track *next();
			bool end();
		} /* Namespace: iter */

		struct PathInfo {
			string path;
			unsigned int size;
		};

		void load();
		void save();
		void update();
		void update_path(string);
		void refresh();

		string next_file();
		void add_path(string);
		void remove_path(string);
		string find_filepath(sid_t &);
		Track *get_info(sid_t &);
		void for_each_path(void (*)(struct PathInfo &));

		void list_track(libsaria::Track *);
		void unlist_track(libsaria::Track *);
		unsigned int size();
		void filter(string &text);
		bool is_visible(sid_t &);
	}
}

#endif /* LIBSARIA_LIBRARY_H */
