
#include <libsaria/audio.h>
#include <libsaria/controls.h>
#include <libsaria/track.h>
#include <libsaria/library.h>
#include <libsaria/queue.h>

static bool pause_after_current = false;

namespace libsaria
{

	void play_file(string &filepath)
	{
		if (filepath == "")
			return;

		audio::load(filepath);
		if (pause_after_current == true) {
			audio::pause();
			pause_after_current = false;
		} else
			audio::play();

	}

	string next_file()
	{
		if (queue::size() > 0)
			return queue::next_file();
		else
			return library::next_file();
	}

	void next()
	{
		string filepath = next_file();
		play_file(filepath);
	}

	void play_id(sid_t &songid)
	{
		println("Playing id: %lu", songid);
		string filepath = library::find_filepath(songid);
		println(filepath);
		play_file(filepath);
	}

	void set_pause_after(bool state)
	{
		pause_after_current = state;
	}

	bool get_pause_after()
	{
		return pause_after_current;
	}

	void toggle_play()
	{
		if (audio::is_playing())
			audio::pause();
		else
			audio::play();
	}

	void rewind()
	{
		audio::seek(-5);
	}

	void forward()
	{
		audio::seek(5);
	}
}; /* Namespace: libsaria */
