
#include <list>
#include <string>
using namespace std;

#include <libsaria/model.h>
#include <libsaria/callback.h>
#include <libsaria/library.h>
#include "library.h"

list<LibraryPath> path_list;

static void do_update(list<LibraryPath>::iterator it)
{
	it->validate();
	it->update();
}

namespace libsaria
{

	void library::for_each_path(void (*info_func)(struct library::PathInfo &))
	{
		list<LibraryPath>::iterator it;
		for (it = path_list.begin(); it != path_list.end(); it++)
			it->get_info(info_func);
	}

	void library::update()
	{
		list<LibraryPath>::iterator it;
		for (it = path_list.begin(); it != path_list.end(); it++)
			do_update(it);
	}

	void library::update_path(string dir)
	{
		list<LibraryPath>::iterator it;
		for (it = path_list.begin(); it != path_list.end(); it++) {
			if (it->get_path() == dir)
				do_update(it);
		}
	}

	void library::refresh()
	{
		trigger_callback(LIBRARY_REFRESH);
	}

	void library::add_path(string dir)
	{
		path_list.push_back(LibraryPath(dir));
		path_list.back().update();
	}

	void library::remove_path(string dir)
	{
		list<LibraryPath>::iterator it;

		for (it = path_list.begin(); it != path_list.end(); it++) {
			if (it->get_path() == dir) {
				it->prepare_for_removal();
				path_list.erase(it);
				save();
				refresh();
				return;
			}
		}
	}


}; /* namespace: libsaria */
