
#include <libsaria/track.h>
#include <libsaria/index.h>
#include <libsaria/library.h>
#include <libsaria/print.h>
#include "list.h"

#include <list>
using namespace std;

list<libsaria::Track *> track_list;

static bool compare_tracks(libsaria::Track *one, libsaria::Track *two)
{
	/* I want to compare tracks and not pointers */
	return *one < *two;
}

namespace libsaria
{

	void library::list_track(libsaria::Track *track)
	{
		track_list.push_back(track);
	}

	void library::unlist_track(libsaria::Track *track)
	{
		track_list.remove(track);
	}

	void library::sort_list()
	{
		track_list.sort(compare_tracks);
	}

	unsigned int library::size()
	{
		if (index::is_filtered() == true)
			return index::size();
		return track_list.size();
	}

	Track *library::get_info(sid_t &songid)
	{
		list<libsaria::Track *>::iterator it;
		for (it = track_list.begin(); it != track_list.end(); it++) {
			if ((*it)->get_songid() == songid)
				return *it;
		}
		return NULL;
	}

}
