
#include <ocarina/header.h>
#include <ocarina/button.h>
#include "header.h"

static GtkWidget *header = NULL;

static void make_header()
{
	GtkWidget *sep = gtk_hseparator_new();
	GtkWidget *content = gtk_hbox_new(FALSE, 0);

	box_pack_start(content, get_entry(),          TRUE,  TRUE,  0);
	box_pack_start(content, make_open_button(),   FALSE, FALSE, 0);
	box_pack_start(content, make_random_button(), FALSE, FALSE, 0);
	box_pack_start(content, make_volume_button(), FALSE, FALSE, 0);

	header = gtk_vbox_new(FALSE, 0);
	box_pack_start(header, content, FALSE, FALSE, 0);
	box_pack_start(header, sep,     FALSE, FALSE, 0);

	gtk_widget_show_all(header);
}

GtkWidget *get_header()
{
	if (header == NULL)
		make_header();
	g_object_ref(header);
	return header;
}

void put_header()
{
	if (header != NULL)
		g_object_unref(header);
}
